# encoding: UTF-8
#
# Cookbook Name:: zookeeper_bridge
# Provider:: wait
# Author:: Xabier de Zuazo (<xabier@onddo.com>)
# Copyright:: Copyright (c) 2014 Onddo Labs, SL. (www.onddo.com)
# License:: Apache License, Version 2.0
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

def whyrun_supported?
  true
end

def server
  new_resource.server || node['zookeeper_bridge']['server']
end

action :run do
  converge_by("wait #{new_resource}") do
    zk_locker = Chef::ZookeeperBridge::StatusLocker.new(server)
    case new_resource.status.to_sym
    when :created
      zk_locker.until_znode_created(new_resource.path)
    when :deleted
      zk_locker.until_znode_deleted(new_resource.path)
    end
    unless new_resource.event.to_sym == :none
      zk_locker.until_znode_event(new_resource.path, new_resource.event)
    end
    zk_locker.close
  end
end
